// 
class Agent
{
	Genome Gen; // 
	
	Model M; // 
	Critic C; // 

	boolean was_mating = false; //     . 
		//,           

	double [] input = new double[Param.N_input_Model+1];; //    
	double [] oldS = new double[2]; //    
	double [] S = new double[2]; // 
	double [] u_test = new double[2]; //   ,  
	double [] Vpr_test = new double[2]; //  

	double R; //  
	double u = Param.u; //    
	double old_R = Param.R; //    
	double old_u = Param.u; //      

	double V = 0; //   
	double old_V = 0; //   ,    
	double Vpr = 0; //   

	double dXpr = 0; //    

	int time; //  
	
	public Agent() //   
	{
		Gen = new Genome(); //  
		
		M = new Model(Gen); // 
		C = new Critic(Gen); // 

		R = Param.R; // 
		time = 0; // 

		u_test[0] = 0.0; //  -     
		u_test[1] = 1.0; //  -    
	}

	public Agent(Genome a, Genome b, double R0)//  
	{
		Gen = new Genome(a, b); //     
		
		M = new Model(Gen); // 
		C = new Critic(Gen); // 
	
		R = R0; // 
		time = 0; // 
	
		u_test[0] = 0.0; //  -     
		u_test[1] = 1.0; //  -    
	}

	boolean alive() //,   
	{
		if(time > Param.T) return false; //     

		if(R <= Param.Rmin) return false; //      
	
		return true;		
	}

	void act(double X) //      
	{
		//  .    
		if(time < Param.N_input_Model+1)
		{
			input[time] = X;
			time++;
			return;
		}

		//  
		for(int i = 0; i < Param.N_input_Model; i++)
			input[i] = input[i+1];
		input[Param.N_input_Model] = X;

		//  
		old_R = R;
		double deltaX = input[Param.N_input_Model] - input[Param.N_input_Model-1];
		R = R + Math.log((1 + u * deltaX / input[Param.N_input_Model-1]) * (1 - Param.J * Math.abs(u - old_u)));
		
		//   
		oldS[0]=S[0];
		oldS[1]=S[1];
		S[0] = Param.k * deltaX;
		S[1] = u;

		// 
		old_V = V;
		V = C.work(S);

		// 
		double r = R - old_R;
		r = Param.k*r;

		//  
		double delta = r + Param.gamma * V - old_V;

		// 
		C.learning(delta, oldS);

		// 
		double error = dXpr - Param.k*deltaX;
		M.learning(error);

		// 
		double [] temp = new double[Param.N_input_Model];
		for(int i = 0; i < Param.N_input_Model; i++)
			temp[i] = Param.k*(input[i+1] - input[i]);
		dXpr = M.work(temp);
		
		// 
		for(int i_test=0; i_test < 2; i_test++)
		{  
			double [] Spr = new double[2];
			Spr[0] = dXpr;
			Spr[1] = u_test[i_test];

			Vpr_test[i_test] = C.work(Spr);
		}

		// 
		old_u = u;
		double Vmax = Vpr_test[0];
		int selected_acton = 0;
		if(Vpr_test[1] > Vmax) 	selected_acton = 1; 
		
		if(Param.rnd.nextDouble() < Param.epsilon)
		{
			selected_acton = 0; 
			if(Param.rnd.nextDouble() > 0.5) selected_acton = 1;
		} 	
			
		Vpr = Vpr_test[selected_acton];
		u = u_test[selected_acton];

		//  
		time++;
	}
}