// 
public class Critic extends NeuralNetwork
{
	//  ,       
	boolean learn = false;

	//   
	double sum_Critic = 0;

	// .        
	public Critic(Genome G)
	{
		super(2, G.Nh_C, G.VC, G.WC);
	}

	//    
	double sumCritic(double [] in)
	{
		
		//  
		for(int i = 0; i < N_input; i++)
			input[i] = in[i];
		
		//    
		for(int j = 0; j < N_hidden; j++)
		{
			double sum = 0;
			for(int i = 0; i < N_input; i++)
				sum += W[i][j]*input[i];
			hidden[j] = th(sum);
		}
	
		//  
		sum_Critic = 0;
		for(int j = 0; j < N_hidden; j++)
			sum_Critic += V[j] * (1 - hidden[j] * hidden[j]) * W[1][j];
					
		return sum_Critic;
	}

	//     
	void learning(double delta, double[] in)
	{
		//     
		if(!learn)
		{
			learn = true;
			return;
		}
	
		//  
		for(int i = 0; i < N_input; i++)
			input[i] = in[i];
		
		//    
		for(int j = 0; j < N_hidden; j++)
		{
			double sum = 0;
			for(int i = 0; i < N_input; i++)
				sum += W[i][j]*input[i];
			hidden[j] = th(sum);
		}

		//   
		for(int j = 0; j < N_hidden; j++)
		{
			for(int i = 0; i < N_input; i++)
				W[i][j] += Param.alfa_Critic * delta * V[j] * (1 - hidden[j] * hidden[j]) * input[i];
			V[j] += Param.alfa_Critic * delta * hidden[j];
		}
	}
}