//  .  .
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import java.lang.String.*;

public class Main extends Frame
{
	boolean working = false; //  
	int Ntact = 10000; // 

	int Tmax = 10000; //    

	String DataFileName = new String(""); //    
	String DataFileDir = new String(""); // ,       

	class MainWA extends WindowAdapter
	{
		public void windowClosing(WindowEvent e)
		{
			System.exit(0);
		}
	}

	public Main()
	{
		//   
		super();
		this.addWindowListener(new MainWA());
		initFrame();
		this.show();
		this.setTitle("Initialising...");

		//   
		TextField_RIN.setText(Long.toString(Param.init));
		TextField_NTact.setText(Integer.toString(Ntact));
		TextField_DataFile.setText(DataFileName);

		this.setTitle("Ready");
	}

	public void dispose()
	{
		super.dispose();
	}

	// ,      
	TextField TextField_RIN = new TextField();
	TextField TextField_NTact = new TextField();
	TextField TextField_DataFile = new TextField();

	Label label1 = new Label();
	Label label2 = new Label();
	Label label3 = new Label();
	Label label4 = new Label();
	Label label5 = new Label();
	Label label6 = new Label();

	Button buttonChange = new Button();
	Button buttonStart = new Button();
	Button buttonExit = new Button();
	Button buttonParam1 = new Button();
	Button buttonParam2 = new Button();
	Button buttonParam3 = new Button();

	private void initFrame()
	{
		this.setBackground(Color.lightGray);
		this.setTitle("Main");
		this.resize(370, 320);
		this.setResizable(false);
		this.setLayout(null);

		label1.setText("Control System Parameters");
		label1.setBounds(new Rectangle(20, 40, 230, 25));

		label2.setText("Parameters of Flying and Communication");
		label2.setBounds(new Rectangle(20, 70, 230, 25));

		label3.setText("Parameters of Evolution");
		label3.setBounds(new Rectangle(20, 100, 230, 25));

		label4.setText("Data File");
		label4.setBounds(new Rectangle(20, 150, 100, 25));

		label5.setText("Random Initialization Number");
		label5.setBounds(new Rectangle(20, 200, 180, 20));

		label6.setText("Number of Tacts");
		label6.setBounds(new Rectangle(20, 230, 180, 20));

		TextField_DataFile.setBounds(new Rectangle(150, 150, 100, 25));
		TextField_RIN.setBounds(new Rectangle(200, 200, 50, 20));
		TextField_NTact.setBounds(new Rectangle(200, 230, 50, 20));

		buttonChange.setLabel("Change");
		buttonChange.setBounds(new Rectangle(270, 150, 80, 25));
		buttonStart.setLabel("Start");
		buttonStart.setBounds(new Rectangle(70, 270, 80, 25));
		buttonExit.setLabel("Exit");
		buttonExit.setBounds(new Rectangle(220, 270, 80, 25));

		buttonParam1.setLabel("Change");
		buttonParam1.setBounds(new Rectangle(270, 40, 80, 25));
		buttonParam2.setLabel("Change");
		buttonParam2.setBounds(new Rectangle(270, 70, 80, 25));
		buttonParam3.setLabel("Change");
		buttonParam3.setBounds(new Rectangle(270, 100, 80, 25));

		buttonExit.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonExit_actionPerformed(e);
			}
		});

		buttonStart.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonStart_actionPerformed(e);
			}
		});

		buttonChange.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonChange_actionPerformed(e);
			}
		});

		buttonParam1.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonParam1_actionPerformed(e);
			}
		});

		buttonParam2.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonParam2_actionPerformed(e);
			}
		});

		buttonParam3.addActionListener(new java.awt.event.ActionListener()
		{
			public void actionPerformed(ActionEvent e)
			{
				buttonParam3_actionPerformed(e);
			}
		});

		this.add(label1, null);
		this.add(label2, null);
		this.add(label3, null);
		this.add(label4, null);
		this.add(label5, null);
		this.add(label6, null);

		this.add(buttonParam1, null);
		this.add(buttonParam2, null);
		this.add(buttonParam3, null);

		this.add(TextField_DataFile, null);

		this.add(buttonChange, null);

		this.add(TextField_RIN, null);
		this.add(TextField_NTact, null);

		this.add(buttonStart, null);
		this.add(buttonExit, null);
	}

	public static void main(String args[])
	{
		Main main1 = new Main();
	}

	//    
	static boolean readData(double [] data, int num, String filename)
	{
		int b;
		int index = 0;

		try
		{
			File file = new File(filename);
			FileInputStream f = new FileInputStream(file);
			try
			{
				b = f.read();
				while(b != -1)
				{
					String str = new String();
					while(b != 13)
					{
						char [] temp = new char [1];
						temp[0] = (char)b;
						String buf = new String(temp);
						str = str.concat(buf);
						b = f.read();
					}
					b = f.read();
					b = f.read();
					if(index >= num)
						break;
					Double d = Double.valueOf(str);
					data[index] = d.doubleValue();
					index++;
				}
				f.close();
			}
			catch(IOException e)
			{
				return false;
			}
		}
		catch(FileNotFoundException e)
		{
			return false;
		}
		return true;
	}

	//  
	void buttonExit_actionPerformed(ActionEvent e)
	{
		if(!working)
		{
			System.exit(0);
		}
	}

	//     
	void buttonParam1_actionPerformed(ActionEvent e)
	{
		ParamAgent PA = new ParamAgent();		
	}

	//      
	void buttonParam2_actionPerformed(ActionEvent e)
	{
		ParamFlyCom PFC = new ParamFlyCom();		
	}

	//    
	void buttonParam3_actionPerformed(ActionEvent e)
	{
		ParamEvol PE = new ParamEvol();		
	}

	// 
	void buttonStart_actionPerformed(ActionEvent e)
	{
		// 
		working = true;
		this.setTitle("Setting up the parameters");

		Param.init = (Long.valueOf(TextField_RIN.getText())).longValue();
		Ntact = (Integer.valueOf(TextField_NTact.getText())).intValue();
		Param.rnd = new Random(Param.init);

		this.setTitle("Reading the data from the file");

		double [] Data;//

		//     
		Data = new double[Ntact];
		if(!readData(Data, Ntact, DataFileDir + DataFileName))
		{
			working = false;
			this.setTitle("Cannot find the file");
			return;
		}

		this.setTitle("Working");

		// 
		Net newNet = new Net();

		//     
		System.out.print("time\t");
		System.out.print("price\t\t");
		for(int k = 0; k < Param.NP; k++)
		{
			System.out.print("N" + k + "\t");
			System.out.print("<R" + k + ">\t");
			System.out.print("Rmax_" + k + "\t");
			System.out.print("<u" + k + ">\t");
			System.out.print("N_birth_" + k + "\t");
			System.out.print("N_death_" + k + "\t");
			System.out.print("N_com_" + k + "\t");
			System.out.print("N_fly_" + k + "\t\t");
		}
		System.out.println();

		int dt = Ntact / Tmax; //  

		//   
		int done = 0;
		double one = Ntact/100;

		//  , ,     
		//      
		int [] Nb = new int[Param.NP];
		int [] Nd = new int[Param.NP];
		int [] Nc = new int[Param.NP];
		int [] Nf = new int[Param.NP];
		for(int i1 = 0; i1 < Param.NP; i1++)
		{
			Nb[i1] = 0;
			Nd[i1] = 0;
			Nc[i1] = 0;
			Nf[i1] = 0;
		}

		//
		for(int i = 0; i < Ntact; i++)
		{
			double X = Data[i]; // .    

			newNet.act(X); //     

			//  , ,     
			//      
			for(int i1 = 0; i1 < Param.NP; i1++)
			{
				Nb[i1] += newNet.Nodes[i1].N_birth;
				Nd[i1] += newNet.Nodes[i1].N_death;
				Nc[i1] += newNet.Nodes[i1].N_com;
				Nf[i1] += newNet.Nodes[i1].Outgoing.size();
			}

			//         
			if(i % dt == 0)
			{
				System.out.print(i + "\t");
				System.out.print(X + "\t\t");
				for(int k = 0; k < Param.NP; k++)
				{
					//   R  u   R  
					double mean_R = 0;
					double mean_u = 0;
					double Rmax = Param.Rmin;
					int n = newNet.Nodes[k].Agents.size();
					for(int j = 0; j < n; j++)
					{
						mean_R += ((Agent)(newNet.Nodes[k].Agents.elementAt(j))).R;
						mean_u += ((Agent)(newNet.Nodes[k].Agents.elementAt(j))).u;
						Rmax = Math.max(((Agent)(newNet.Nodes[k].Agents.elementAt(j))).R, Rmax);
					}
					mean_R /= n;	
					mean_u /= n;	
					
					System.out.print(n + "\t"); //    
					System.out.print(mean_R + "\t"); //    
					System.out.print(Rmax + "\t"); //    
					System.out.print(mean_u + "\t"); //        
					System.out.print(Nb[k] + "\t"); //        
					System.out.print(Nd[k] + "\t"); //        
					System.out.print(Nc[k] + "\t"); //       
					System.out.print(Nf[k] + "\t\t"); //  ,      
				}
				System.out.println();
			
				//  , ,     
				//      
				for(int i1 = 0; i1 < Param.NP; i1++)
				{
					Nb[i1] = 0;
					Nd[i1] = 0;
					Nc[i1] = 0;
					Nf[i1] = 0;
				}			
			}
		
			//   
			if(i > done*one)
			{
				this.setTitle("Working... " + done + "% done");
				done++;
			}
		}
		working = false;
		this.setTitle("Ready");
		return;
	}

	//    
	void buttonChange_actionPerformed(ActionEvent e)
	{
		FileDialog load = new FileDialog(this);
		load.setDirectory("");
		load.show();
		DataFileDir = load.getDirectory();
		DataFileName = load.getFile();
		TextField_DataFile.setText(DataFileName);
	}
}