//  
import java.util.*;

public class Node
{
	Vector Agents;//   
	Vector Outgoing;// ,      

	int N_com; // ,    
	int N_birth; //     
	int N_death; //     

	int NetLevel;//    
	int [] Levels = new int [Param.kmax];// 
	int time = 0;// 

	// .  .
	public Node()
	{
		Agents = new Vector(Param.NA, 1);
		for(int i = 0; i < Param.NA; i++)
		{
			Agent tAgent;
			tAgent = new Agent();
			Agents.addElement(tAgent);
		}
		Outgoing = new Vector(0, 1);
	}

	//     
	void act(double X)
	{
		N_death = 0;
	
		for(int i = 0; i < Agents.size(); i++)
		{
			// 
			Agent a = (Agent)(Agents.elementAt(i));

			//     
			a.act(X);
		
			//  
			if(!a.alive())
			{
				Agents.removeElementAt(i);
				N_death++;
				i--;
			}
		}
	}

	//   ,   .     .   .
	public int trytoMate()
	{
		//   
		N_com = 0;
		N_birth = 0;		

		NetLevel = 0;
		for(int i = 0; i < Agents.size(); i++)
		{
			Agent a = (Agent)Agents.elementAt(i);

			//    
			if(a.R >= Param.Rm)
			{
				// 
				if(Param.rnd.nextDouble() < Param.P_com)
				{
					NetLevel++;
					a.R -= Param.dR_com;
					N_com++;
				}

				//   ,    
				if(a.was_mating) continue;

				// 
				for(int j = i+1; j < Agents.size(); j++)
				{
					Agent b = (Agent)Agents.elementAt(j);

					if(b.R >= Param.Rm)// 
					{
						//  
						Agent tAgent;
						tAgent = new Agent(a.Gen, b.Gen, 0.25 * (a.R + b.R));
						Agents.addElement(tAgent);
						N_birth++;

						// a  b    
						a.R = 0.75 * a.R;
						b.R = 0.75 * b.R;
						a.was_mating = true;
						b.was_mating = true;

						// 
						if(Param.rnd.nextDouble() < Param.P_com)
						{
							NetLevel++;
							b.R -= Param.dR_com;
						}
						break;
					}
				}
			}
		}
		return NetLevel;
	}

	//           
	public Vector fly(int L)
	{	
		//   
		Outgoing.removeAllElements();

		// Levels[]
		if(time >= Param.kmax)
		{
			for(int i = 0; i < Param.kmax-1; i++)
				Levels[i] = Levels[i+1];
			Levels[Param.kmax-1] = L;
		}
		else
			Levels[time] = L;

		//  
		int Level = 0;
		for(int i = 0; i < Math.min(time, Param.kmax); i++)
			Level += Math.pow(Param.y, i)*Levels[i];

		//    
		double P_fly = Param.P_fly_max * th(Param.kapa*Level);
		for(int i = 0; i < Agents.size(); i++)
		{
			Agent a = (Agent)Agents.elementAt(i);
			if(a.was_mating) a.was_mating = false;

			if(a.R >= Param.Rm)//    ,      
			{
				if(Param.rnd.nextDouble() < P_fly)//   
				{
					a.R -= Param.dR_fly;
					Outgoing.addElement(a);
					Agents.removeElementAt(i);
					continue;
				}
			}

		}
		time++;
		return Outgoing;
	}

	// ,   
	public void getAgent(Agent a)
	{
		Agents.addElement(a);
	}

	protected double th(double x)
	{
		return (Math.exp(x) - Math.exp(-x))/(Math.exp(x) + Math.exp(-x));
	}
}